<?php

namespace ChangeCommerce\Core\Helpers;

use Magento\Framework\App\ObjectManager;
use ChangeCommerce\Core\Logger\Logger;

class OrderObjHelper
{
    protected $_objectManager;
    protected $_logger;

    public function __construct(Logger $logger)
    {
        $this->_objectManager = ObjectManager::getInstance();
        $this->_logger = $logger;
    }

    public function getOrderObjById($id) {

        $order = $this->_objectManager->create('\Magento\Sales\Model\OrderRepository')->get($id);
        $collection = $this->_objectManager->create('Magento\Sales\Model\Order');
        $order = $collection->loadByIncrementId($id);
        
        $orderObj['customerId'] = $order->getCustomerId();
        $orderObj['entityId'] = $order->getEntityId();
        $orderObj['incrementId'] = $order->getIncrementId();
        $orderObj['state'] = $order->getState();
        $orderObj['status'] = $order->getStatus();
        $orderObj['storeId'] = $order->getStoreId();
        $orderObj['grandTotal'] = $order->getBaseGrandTotal();
        $orderObj['subtotal'] = $order->getBaseSubtotal();
        $orderObj['totalQtyOrdered'] = $order->getTotalQtyOrdered();
        $orderObj['orderCurrencyCode'] = $order->getOrderCurrencyCode();
        $orderObj['customerLastName'] = $order->getCustomerLastname();
        $orderObj['customerFirstName'] = $order->getCustomerFirstname();
        $orderObj['amount'] = $order->getPayment()->getAmountPaid();
        $orderObj['discountAmount'] = $order->getBaseDiscountAmount();
        $orderObj['couponCode'] = $order->getCouponCode();
        $orderObj['createdAt'] = $order->getCreatedAt();
        $orderObj['lineItems'] = [];
        
        $orderItems = $order->getAllVisibleItems();
        foreach ($orderItems as $item) {
            $itemObj['lineItemId'] = $item->getItemId();
            $itemObj['orderId'] = $item->getOrderId();
            $itemObj['productId'] = $item->getProductId();
            $itemObj['sku'] = $item->getSku();
            $itemObj['name'] = $item->getName();
            $itemObj['sku'] = $item->getSku();
            $itemObj['qty'] = $item->getQtyOrdered();
            $itemObj['qtyRefunded'] = $item->getQtyRefunded();
            $itemObj['qtyCanceled'] = $item->getQtyCanceled();
            $itemObj['price'] = $item->getBasePrice();
            $itemObj['basePrice'] = $item->getBasePrice();
            $itemObj['rowTotal'] = $item->getRowTotal();
            $itemObj['discountRefunded'] = $item->getBaseDiscountRefunded();
            $itemObj['discountAmount'] = $item->getBaseDiscountAmount();
            $itemObj['discountPercent'] = $item->getBaseDiscountAmount();

            array_push($orderObj['lineItems'], $itemObj);
        }

        return $orderObj;
    }
}
