<?php
namespace ChangeCommerce\Core\Setup;

use Magento\Framework\DB\Ddl\Table;
use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

/**
 * Class UpgradeSchema
 * @package ChangeCommerce\Core\Setup
 */
class UpgradeSchema implements UpgradeSchemaInterface
{
    /**
     * @param SchemaSetupInterface $setup
     * @param ModuleContextInterface $context
     *
     * @throws Zend_Db_Exception
     */
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();
        $connection = $installer->getConnection();

        if (!$installer->tableExists('changecommerce_order_webhook_failures')) {
            $table = $connection
                ->newTable($installer->getTable('changecommerce_order_webhook_failures'))
                ->addColumn(
                    'id',
                    Table::TYPE_INTEGER,
                    null,
                    ['identity' => true, 'nullable' => false, 'primary' => true, 'unsigned' => true],
                    'Id'
                )
                ->addColumn('hook_name', Table::TYPE_TEXT, 255, [], 'Hook Name')
                ->addColumn('step', Table::TYPE_INTEGER, null, [], 'Step Failed On')
                ->addColumn('response', Table::TYPE_TEXT, null, [], 'Response')
                ->addColumn('response_status_code', Table::TYPE_INTEGER, null, [], 'Response Status Code')
                ->addColumn('message', Table::TYPE_TEXT, 512, [], 'Message')
                ->addColumn('order_id', Table::TYPE_INTEGER, null, [], 'Order ID')
                ->addColumn('request_body', Table::TYPE_TEXT, null, [], 'Request Body')
                ->addColumn('request_uri', Table::TYPE_TEXT, null, [], 'Request URI')
                ->addColumn('request_headers_json', Table::TYPE_TEXT, '2M', [], 'Request Headers JSON')
                ->addColumn('request_verb', Table::TYPE_TEXT, 32, [], 'Request Headers JSON')
                ->addColumn(
                    'created_at',
                    Table::TYPE_TIMESTAMP,
                    null,
                    ['default' => Table::TIMESTAMP_INIT],
                    'Created At'
                )
                ->setComment('ChangeCommerce Order Webhook Failure Log Table');

            $connection->createTable($table);
        }
        $installer->endSetup();
    }
}
